#include <stdio.h>
#include <stdlib.h>

static unsigned short
nextstep_checksum(buf, limit)
    unsigned char *buf;
    unsigned char *limit;
{
    long int sum = 0;

    while (buf < limit) {
        sum += (unsigned)(buf[0] << 8) + buf[1];
        buf += 2;
    }
    sum += (sum >> 16);
    return (sum & 0xffff);
}

int main(int argc, char *argv[])
{
    char *inputFilename;
    FILE *inputFile;
    char buf[0x22E];
    int n;
    unsigned short cksum;

    if (argc != 2)
    {
        fprintf(stderr, "Usage: ns_cksum <file>");
        exit(1);
    }

    inputFilename = argv[1];
    inputFile = fopen(inputFilename, "rb");
    if (!inputFile)
    {
        fprintf(stderr, "Error: cannot open file");
        exit(1);
    }

    n = fread(buf, 1, sizeof buf, inputFile);
    if (n != sizeof buf)
    {
        fprintf(stderr, "Error: file too short");
        exit(1);
    }

    cksum = nextstep_checksum(buf, buf + sizeof buf);
    printf("%4X", cksum);

    return 0;
}
